' FileName: EList.Bas
' Date: 6/03/2017
' Author: Ben Ritchey
' Description: FIDONet EchoList Database program

#COMPILER PBCC 5
#COMPILE EXE
#DIM ALL

DECLARE FUNCTION TextInput(TCol as Long, CurFile AS STRING, Buffer AS STRING, _
                        Row AS LONG, Col AS LONG, History() AS STRING) AS LONG

FUNCTION PBMAIN () AS LONG

Local PgmVer as String
Local RC as long
Local Tail1, Head1, Head2, Head3, Spacer1, Spacer2, A, B, C, D, Z as string
Local XIdx, ECOMax, EoTFlag, WVol, ELen, TblMax, TRec, I, J, K, L, M as long
Local WReply, WMess, WGate, WGrp, WDist, WRest, WOrig, WDomain, WDesc as string
Local TYyyy, TMm, TDd, WYyyy, WMm, WDd, WZone, WNet, WNode, WPoint as integer
Local XTitl, XDesc, XRec, XTag, XPW, XPWNew, XFrom, f, T, WUpd as string
Local Y, X, XUI, XUser, XDist, XGate, XGroup, XVol, XRest, XOrig as string
Local CC, LL, TT, Warn, Q, II, O, P, RFlag, ECOCnt as long
Local WEmail, H, XSubj, XMod, XCoMod1, XCoMod2, XCoMod3, XCoMod4 as string
Local PostMod, RUC, WRule, XRule, PDate, XReply, PvtEmail as string
Local BitShift as long
LOCAL MONTHTAB() AS STRING
Local AA as integer
Local RUFlag, retVal, CX, CY, TCol, Row, Col AS LONG
Local Z4, Z1, Z2, Z3, WTitl, CurFile, Buffer AS STRING
Local History() AS STRING

REDIM history1(0) AS STRING  'add a history array for each text field if needed.

' Do NOT change format of next line except x-x !!!
  PgmVer=" EList v4.3.C "

RC=0: TCol=132: TblMax=2000: ELen=4500: ECOMax=250
Print PgmVer;" {c} 2017 Ben Ritchey"
Dim TagTbl(TblMax,3) as string
Dim TmpTbl(1,3) as string
Dim ECOTbl(ECOMax) as string

Dim MONTHTAB(12)  ' See Data statements at end of Function
  FOR L=1 TO 12
    MONTHTAB(L)=READ$(L)
   NEXT L

  PDate="as of  "+MONTHTAB(VAL(MID$(DATE$,1,2)))+STR$(VAL(MID$(DATE$,4,2)))
  A="th": AA=VAL(MID$(DATE$,4,2))
  IF AA=1 OR AA=21 OR AA=31 THEN A="st"
  IF AA=2 OR AA=22 THEN A="nd"
  IF AA=3 OR AA=23 THEN A="rd"
  PDate=PDate+A+", " + MID$(DATE$, 7, 4)
  A="": AA=0

StartUp:

I=1
Open "EList.DB" for binary access read write as #1
Open "EList.Log" for append as #5

' Everybody needs a memory resident index to EList.DB !!!
'   1. TAGname 1-36 bytes
'   2. Record location in file (string! use val() )
'   3. TITLe 1-72 bytes

While not eof(1) and I<=TblMax
  Get$ #1,ELen,A
  If trim$(mid$(A,2,36),chr$(0))="" goto Skipit  ' null record?

  TagTbl(I,1)=trim$(mid$(A,2,36),chr$(0))
  TagTbl(I,2)=trim$(str$(((I-1)*ELen)+1))
  TagTbl(I,3)=trim$(mid$(A,38,72),chr$(0))
  I=I+1
Skipit:
Wend

TRec=I-1
Print: Print TRec;" records indexed"
Print #5,date$;" ";time$;" ==> ";TRec;" record indices loaded:"

If instr(ucase$(command$),"REPORT")>0 then goto DoReport
If instr(ucase$(command$),"UPDATE")>0 then goto DoUpdate
If instr(ucase$(command$),"MAINT")>0 then goto DoMaint
If instr(ucase$(command$),"SORTONLY")>0 then goto DoSort
If instr(ucase$(command$),"SORTPACK")>0 then goto DoSort
If instr(ucase$(command$),"WARN")>0 then goto DoWarn
Beep
Goto EndItAll

' WARNings option * * * * * * * * * * * * * * * * * * * * * * * * * * *

DoWarn:

I=1
While I<=TRec

  Seek #1,val(TagTbl(I,2))  ' Position to record
  Get$ #1,ELen,XRec
  PvtEmail=""

  If cvbyt(XRec,2440)=1 then goto SkipDel2  ' skip Pending Deletes
  If cvbyt(XRec,2439)>=3 then goto WarnDel  ' Flag for deletion

  WYyyy=cvwrd(XRec,2435)  ' yyyy Updated last
  WMm=cvbyt(XRec,2437)  ' mm
  WDd=cvbyt(XRec,2438)  ' dd
  TYyyy=val(mid$(date$,7,4))  ' yyyy Today's date
  TMm=val(mid$(date$,1,2))  ' mm
  TDd=val(mid$(date$,4,2))  ' dd

  If WYyyy=TYyyy then M=TMm-WMm  ' figure #months
  If WYyyy+1=TYyyy then M=(12-WMm)+TMm
  If WYyyy+1<TYyyy then M=13
  If M<1 then M=1
  If M<12 then goto SkipDel2  ' Skip if Ok

  mid$(XRec,2439,1)=mkbyt$((cvbyt(XRec,2439)+1))  ' Bump Warn count

  Z="==> WARNing "+trim$(str$(cvbyt(XRec,2439)))+" of 4: This Echo is expiring, please Update."

DoAll:

  WReply=trim$(mid$(XRec,2477,80),chr$(0))
  WEmail=trim$(mid$(XRec,2319,80),chr$(0))
  If WReply<>"" then WEmail=WReply  ' Reply-to overrides From
  If WEmail<>"" then gosub DoPvtEm

  Open "EListUpd.Txt" for output as #3
  If PvtEmail<>"" then print #3,"To: "+PvtEmail
  Print #3,Z  ' Warning msg ...
  Print #5,date$;" ";time$;" ";Z;" {";trim$(mid$(XRec,2,36),chr$(0));"}"  ' Log
  Print #3

  RFlag=1
  A=XRec
  Gosub JumpRpt  ' Gosub Report, single echo ...
  RFlag=0
  Close #3

  Seek #1,val(TagTbl(I,2))  ' Position to record then write
  Put$ #1,XRec

'  Print "Delay for 3 secs ..."
'  Sleep 3000
'  Q=Timer+3  ' Delay for MsgID
'  While Timer<Q
'  WEnd

  If PvtEmail="" then goto EchoIt

  ' EListUp.Bat arg 1 (%1) is TAGname,
  '             arg 2 (%2) is Email addy,
  '             arg 3 (%3) is Option (0)
  '             arg 4 (%4) is Warn count n

  Shell "cmd /c elistup.bat "+TagTbl(I,1)+" "+PvtEmail+" 0 "+trim$(str$(cvbyt(XRec,2439)))

'  Z=Z+" Expiration WARNing "+chr$(34)
'  Z=Z+" 337:1/0 /t=elistupd.txt /o"+chr$(34)+"FIDONet EList v4 MaintBot"+chr$(34)
'  Z=Z+" /a"+chr$(34)+"Internet Rex"+chr$(34)
'  Shell Z

EchoIt:

  Z1="110": Z2="MaintBot": Z3=TagTbl(I,1)+" Expiration WARNing #"+trim$(str$(cvbyt(XRec,2439)))
  Gosub BuildIni

  Shell "cmd /c elistup.bat NA NA 1"
  
SkipDel2:

  I=I+1

WEnd  

Goto EndItAll

WarnDel:

  Z="==> WARNing: This Echo has Expired & will be Deleted in 30 days."
  mid$(XRec,2440,1)=mkbyt$(1) ' Flag for Delete
  mid$(XRec,2439,1)=mkbyt$((cvbyt(XRec,2439)+1))  ' Bump Warn count

Goto DoAll

DoPvtEm:  ' convert {at} in WEmail to @ in PvtEmail
  PvtEmail=WEmail
  Q=instr(WEmail,"{at}")
  If Q>0 then
    PvtEmail=mid$(WEmail,1,Q-1)+"@"+mid$(WEmail,Q+4)
  End if
  If instr(PvtEmail,"@")=0 then PvtEmail=""
Return

' SORTPACK/SORTONLY options * * * * * * * * * * * * * * * * * * * * * * * *

DoSort:

If TRec<2 then beep: goto EndItAll

For K=TRec to 2 step -1  ' Bubble Sort

J=1
While J<K
  If TagTbl(J,1)>TagTbl(J+1,1) then
    For L=1 to 3: TmpTbl(1,L)=TagTbl(J+1,L): next L
    For L=1 to 3: TagTbl(J+1,L)=TagTbl(J,L): next L
    For L=1 to 3: TagTbl(J,L)=TmpTbl(1,L): next L
  End if
  J=J+1
WEnd

Next K

Open "EList.DB.New" for binary access read write as #2

For L=1 to TRec
  Seek #1,val(TagTbl(L,2))
  Get$ #1,ELen,A
  If cvbyt(mid$(A,2440,1))=1 and instr(ucase$(command$),"SORTPACK")>0 then
    Print #5,date$;" ";time$;" ";trim$(mid$(A,2,36),chr$(0));" Deleted."
    goto SkipDel  ' skip Pending Deletes (Pack)
  End if

' ******** Put auto Database conversions here then do SortPack ********
'  mid$(A,1,1)=chr$(41)  ' Version

  Put$ #2,A
SkipDel:
Next L

Goto EndItAll

' UPDATE option * * * * * * * * * * * * * * * * * * * * * * * * * * *

DoUpdate:

Open "\EListBsy.Flg" for output as #7
Print #7,"This semaphore says do NOT run mutil as elist needs it!"
'  This file MUST be deleted at exit, see EndItAll ...
Close #7

shell "cmd /c dir /b *.eco >ecofiles.txt"
open "ecofiles.txt" for input as #6

While not eof(6)

  line input #6,f
  if f="" then goto EndItAll
  Print "Updating: ";f

  open f for input as #2
  open "EListUpd.Txt" for output as #3

  Z="==> Echo Successfully Updated."  ' preset default
  XTag="": XPW="": XPWNew="": XFrom="": XSubj="": XTitl="": XMod="?~?"
  PvtEmail=""

  II=1: RUFlag=0
  While not eof(2) and II<ECOMax

    line input#2,B
    If RUFlag=1 then goto CopyRul

    If ucase$(mid$(B,1,4))="FROM" then  ' Set ECO source
      XFrom=trim$(mid$(B,instr(B," ")+1))
    End if  

    If ucase$(mid$(B,1,4))="SUBJ" then  ' Set ECO subject
      XSubj=trim$(mid$(B,instr(B," ")+1))
    End if  

    If ucase$(mid$(B,1,4))="HELP" then  ' Post Help file
      Z="HELP File Requested:"
      gosub PostHelp
      goto ECOEnd
    End if  

    If ucase$(mid$(B,1,3))="TAG" then  ' Set ECO area TAG
      XTag=ucase$(trim$(mid$(B,instr(B," ")+1)))
    End if  

    If ucase$(mid$(B,1,4))="PASS" then  ' Set/Reset ECO PW
      H=trim$(mid$(B,instr(B," ")+1))
      Q=instr(H,",")
      If Q>0 then
        XPW=trim$(mid$(H,1,Q-1))
        XPWNew=trim$(mid$(H,Q+1))
       Else
        XPW=H
      End if
    End if  

    If ucase$(mid$(B,1,4))="TITL" then
      XTitl=trim$(mid$(B,instr(B," ")+1))  ' TITLe
    End if

    If ucase$(mid$(B,1,3))="MOD" then
      If XMod="?~?" then XMod=""
      XMod=trim$(mid$(B,instr(B," ")+1))  ' MODerator
    End if

    If ucase$(mid$(B,1,8))="RULETEXT" then RUFlag=1

CopyRul:
    ECOTbl(II)=B
    II=II+1

    If mid$(B,1,3)="---" then goto GotDash1  ' End of keywords
    If mid$(B,1,3)="-+-" then goto GotDash1  ' End of keywords

  WEnd

GotDash1:
  ECOCnt=II-1

  If XTag="" then
    Z="TAGname not specified."
    gosub BadMaint
    goto ECOEnd
  End if

  If XPW="" then
    Z="PASSword not specified."
    gosub BadMaint
    goto ECOEnd
  End if

  If XFrom="" then
    Z="Messenger (From) is missing."
    gosub BadMaint
    goto ECOEnd
  End if

  If ucase$(mid$(XSubj,1,3))="MOD" and instr(ucase$(XSubj)," RUL")>0 then
    Z="MOD RUL submissions are under construction."
    gosub BadMaint: goto ECOEnd
  End if

  I=1
  While I<=TRec

NewEcho:
    If XTag=TagTbl(I,1) then
      XIdx=I
      Seek #1,val(TagTbl(I,2))
      Get$ #1,ELen,XRec  ' Set current ECO master record

'      If ucase$(mid$(XSubj,1,3))="MOD" and instr(ucase$(XSubj)," ADD")>0 then
'        Z="Attempt to ADD an existing Echo - invalid."
'        gosub BadMaint: goto ECOEnd
'      End if

      If trim$(mid$(XRec,1975,36),chr$(0))<>XPW then  ' Validate PASSword
        Z="PASSword validation failed."
        gosub BadMaint: goto ECOEnd
      End if

      If cvbyt(XRec,2439)>0 then
        mid$(XRec,2439,1)=chr$(0)  ' Reset Warn count
        Print #3,"==> Expiration Warnings have been Reset": print #3
      End if

      If cvbyt(XRec,2440)=1 then
        mid$(XRec,2439,1)=chr$(0)  ' Reset Warn count
        mid$(XRec,2440,1)=chr$(0)  ' UnDelete
        Print #3,"==> Pending Delete has been Cleared": print #3
      End if

ECOUpdate:
      M=1: XDesc="?~?": XRule="?~?": XVol="?~?": XRest="?~?": XOrig="?~?"
           XDist="?~?": XGate="?~?": XGroup="?~?": XReply="?~?"
           XCoMod1="?~?": XCoMod2="?~?": XCoMod3="?~?": XCoMod4="?~?"

      While M<=ECOCnt
        D=ECOTbl(M)
        If mid$(D,1,2)="---" then goto GotDash2  ' End of keywords
        If mid$(D,1,3)="-+-" then goto GotDash2  ' End of keywords

        If ucase$(mid$(D,1,4))="DESC" then
          If XDesc="?~?" then XDesc=""  ' Allow to Clear the field(s)
          If XDesc<>"" then
            XDesc=XDesc+" "+trim$(mid$(D,instr(D," ")+1))  ' Concat Desc pieces
           else
            XDesc=trim$(mid$(D,instr(D," ")+1))  ' 1st Desc piece
          End if 
          If len(XDesc)>1125 then XDesc=mid$(Xdesc,1,1125)  ' Overflow
        End if

        If ucase$(D)="RULE" or ucase$(mid$(D,1,5))="RULE " or ucase$(mid$(D,1,5))="RULES" then
          If XRule="?~?" then XRule=""  ' Allow to Clear the field(s)
          If XRule<>"" then
            XRule=XRule+" "+trim$(mid$(D,instr(D," ")+1))  ' Concat Rule pieces
           else
            If len(D)>instr(D," ") and instr(D," ")>0 then
              XRule=trim$(mid$(D,instr(D," ")+1))  ' 1st Rule piece
            End if
          End if
          If len(XRule)>1500 then XRule=mid$(XRule,1,1500)  ' Trunc Overflow
        End if

'        If ucase$(mid$(D,1,4))="TITL" then
'          If len(D)>instr(D," ") and instr(D," ")>0 then
'            XTitl=trim$(mid$(D,instr(D," ")+1))  ' TITLe
'          End if
'        End if

        If ucase$(mid$(D,1,3))="VOL" then
          If XVol="?~?" then XVol=""
          If len(D)>instr(D," ") and instr(D," ")>0 then
            XVol=trim$(mid$(D,instr(D," ")+1))  ' VOLume
          End if
        End if

        If ucase$(mid$(D,1,4))="REST" then
          If XRest="?~?" then XRest=""
          If len(D)>instr(D," ") and instr(D," ")>0 then
            XRest=trim$(mid$(D,instr(D," ")+1))  ' RESTrictions
          End if
        End if

        If ucase$(mid$(D,1,4))="ORIG" then
          If XOrig="?~?" then XOrig=""
          If len(D)>instr(D," ") and instr(D," ")>0 then
            XOrig=trim$(mid$(D,instr(D," ")+1))  ' ORIGin
          End if
        End if

        If ucase$(mid$(D,1,4))="DIST" then
          If XDist="?~?" then XDist=""
          If len(D)>instr(D," ") and instr(D," ")>0 then
            XDist=trim$(mid$(D,instr(D," ")+1))  ' DISTribution
          End if
        End if

        If ucase$(mid$(D,1,4))="GATE" then
          If XGate="?~?" then XGate=""
          If len(D)>instr(D," ") and instr(D," ")>0 then
            XGate=trim$(mid$(D,instr(D," ")+1))  ' GATEway
          End if
        End if

        If ucase$(mid$(D,1,5))="GROUP" then
          If XGroup="?~?" then XGroup=""
          If len(D)>instr(D," ") and instr(D," ")>0 then
            XGroup=trim$(mid$(D,instr(D," ")+1))  ' GROUP
          End if
        End if

        If ucase$(mid$(D,1,5))="REPLY" then
          If XReply="?~?" then XReply=""
          If len(D)>instr(D," ") and instr(D," ")>0 then
            XReply=trim$(mid$(D,instr(D," ")+1))  ' REPLY-to
          End if
        End if

        If ucase$(mid$(D,1,5))="COMOD" then

          If XCoMod1="?~?" then
            XCoMod1=""
            XCoMod1=trim$(mid$(D,instr(D," ")+1))  ' COMODerator(s)
            Goto EndCoMod
          End if
          If XCoMod2="?~?" then
            XCoMod2=""
            XCoMod2=trim$(mid$(D,instr(D," ")+1))
            Goto EndCoMod
          End if
          If XCoMod3="?~?" then
            XCoMod3=""
            XCoMod3=trim$(mid$(D,instr(D," ")+1))
            Goto EndCoMod
          End if
          If XCoMod4="?~?" then
            XCoMod4=""
            XCoMod4=trim$(mid$(D,instr(D," ")+1))
            Goto EndCoMod
          End if
          Z="Too many COMODerators (only 4 allowed)."
          gosub BadMaint: goto ECOEnd
        End if

EndCoMod:

    If ucase$(mid$(D,1,8))="RULETEXT" then gosub MakeRul

GotDash2:
        M=M+1
      WEnd

' Finally, everything is ok and we can Update the Master Echolist Database
' record and save!

      If XDesc<>"?~?" then mid$(XRec,110,1125)=XDesc+string$(1125,0)

      If XRule<>"?~?" then mid$(XRec,2589,1500)=XRule+string$(1500,0)
      If XRule="" then
        If isfile("Rules\"+XTag+".RUL") then
          Kill "Rules\"+XTag+".RUL"
          If not isfile("Rules\"+XTag+".RUL") then
            Print #3,"==> Rules file ";XTag+".RUL";" has been Purged."
            Print #3
          End if
        End if
      End if

      If XTitl<>"" then mid$(XRec,38,72)=XTitl+string$(72,0)
      If XVol<>"?~?" then mid$(XRec,2011,4)=mkl$(val(XVol))
      If XRest<>"?~?" then mid$(XRec,2015,72)=XRest+string$(72,0)
      If XOrig<>"?~?" then mid$(XRec,2087,36)=XOrig+string$(36,0)
      If XDist<>"?~?" then mid$(XRec,2123,72)=XDist+string$(72,0)
      If XGate<>"?~?" then mid$(XRec,2195,72)=XGate+string$(72,0)
      If XGroup<>"?~?" then mid$(XRec,2267,16)=XGroup+string$(16,0)
      If XPWNew<>"" then mid$(XRec,1975,36)=XPWNew+string$(36,0)

      If ucase$(mid$(XSubj,1,3))="MOD" and instr(ucase$(XSubj)," DEL")>0 then
        mid$(XRec,2440,1)=chr$(1)  ' Set Pending Delete
        XRule=trim$(mid$(XRec,2589,1500),chr$(0))
        If isfile("Rules\"+XRule) then
          Kill "Rules\"+XRule
          If not isfile("Rules\"+XRule) then
            Print #3,"==> Rules file ";XRule;" has been Purged."
            Print #3
          End if
        End if
        Z="==> Echo has been Flagged for Deletion."
      End if

      XUser=string$(148,0)  ' From (Messenger)
      XUI=XFrom
      Gosub DoUI
      mid$(XRec,2283,148)=XUser

      If XMod<>"?~?" then
        XUser=string$(148,0)  ' MODerator
        XUI=XMod
        Gosub DoUI
        mid$(XRec,1235,148)=XUser
      End if

      If XReply<>"?~?" then
        XUser=string$(148,0)  ' Reply-to
        XUI=XReply
        Gosub DoUI
        mid$(XRec,2441,148)=XUser
      End if

      If XCoMod1<>"?~?" then
        XUser=string$(148,0)  ' COMODerator1
        XUI=XCoMod1
        Gosub DoUI
        mid$(XRec,1383,148)=XUser
      End if

      If XCoMod2<>"?~?" then
        XUser=string$(148,0)  ' COMODerator2
        XUI=XCoMod2
        Gosub DoUI
        mid$(XRec,1531,148)=XUser
      End if

      If XCoMod3<>"?~?" then
        XUser=string$(148,0)  ' COMODerator3
        XUI=XCoMod3
        Gosub DoUI
        mid$(XRec,1679,148)=XUser
      End if

      If XCoMod4<>"?~?" then
        XUser=string$(148,0)  ' COMODerator4
        XUI=XCoMod4
        Gosub DoUI
        mid$(XRec,1827,148)=XUser
      End if

      WYyyy=val(mid$(date$,7,4))  ' Updated date
      mid$(XRec,2435,2)=mki$(WYyyy)  ' yyyy
      mid$(XRec,2437,1)=chr$(val(mid$(date$,1,2)))  ' mm
      mid$(XRec,2438,1)=chr$(val(mid$(date$,4,2)))  ' dd

      mid$(XRec,2439,1)=chr$(0)  ' Clear Warn count

      Seek #1,val(TagTbl(XIdx,2))  ' Get ready & save record
      Put$ #1,XRec

      WReply=trim$(mid$(XRec,2477,80),chr$(0))
      WEmail=trim$(mid$(XRec,2319,80),chr$(0))
      If WReply<>"" then WEmail=WReply  ' Reply-to overrides From
      If WEmail<>"" then gosub DoPvtEm

'      If PvtEmail<>"" then print #3,"To: "+PvtEmail
      Print #3,Z  ' Updated or Added msg ...
      Print #5,date$;" ";time$;" ";Z;" {";trim$(mid$(XRec,2,36),chr$(0));"}"
      Print #3

      RFlag=1
      A=XRec
      Gosub JumpRpt  ' Gosub Report, single echo ...

      RFlag=0

' ******** Debug ********
      If isfile("debug1.flg") then

      M=1
      Print #3
      Print #3,"--------------------- Original submission below ---------------------"
      While M<=ECOCnt
        D=ECOTbl(M)
        If ucase$(mid$(D,1,4))="PASS" then
          Print #3,"PASSword {masked}"
         else
          Print #3,D
        End if
        M=M+1
      WEnd
      Print #3,"                       -=:{  End of Data  }:=- "

      End if
' ******** Debug ********

      Close #3

'      Print "Delay for 3 secs ..."
'      Sleep 3000
'      Q=Timer+3  ' Delay for MsgID
'      While Timer<Q
'      WEnd

      If PvtEmail="" then goto EchoIt2

      ' EListUp.Bat arg 1 (%1) is TAGname,
      '             arg 2 (%2) is Email addy,
      '             arg 3 (%3) is Option (3)

      Shell "cmd /c elistup.bat "+TagTbl(I,1)+" "+PvtEmail+" 3"

'      Z="Cmd /c Imsend m "+chr$(34)+TagTbl(I,1)  ' Reply via Email!
'      Z=Z+" Echolist Update "+chr$(34)
'      Z=Z+" 337:1/0 /t=elistupd.txt /o"+chr$(34)+"FIDONet EList v4 MaintBot"+chr$(34)
'      Z=Z+" /a"+chr$(34)+PvtEmail+chr$(34)
'      Shell Z

EchoIt2:

      Z1="110": Z2="MaintBot": Z3=TagTbl(I,1)+" Echolist Update"
      Gosub BuildIni

      Shell "cmd /c elistup.bat NA NA 1"

      Goto ECOEnd
    End if

  I=I+1
  WEnd

' If we get to here, no Tags match in table so we have to add a NEW echo

  A=chr$(41)+string$(ELen-1,chr$(0))  ' Add NEW Echo

  If XTag="" then
    Z="Invalid or missing TAGname."
    gosub BadMaint: goto ECOEnd
  End if

  If XPW="" then
    Z="Invalid or missing PASSword."
    gosub BadMaint: goto ECOEnd
  End if

  mid$(A,2,36)=ucase$(XTag)+string$(36,chr$(0))
  mid$(A,1975,36)=XPW+string$(36,chr$(0))

  WYyyy=val(mid$(date$,7,4))  ' Creation date yyyymmdd
  mid$(A,2431,2)=mki$(WYyyy)  ' yyyy
  mid$(A,2433,1)=chr$(val(mid$(date$,1,2)))  ' mm
  mid$(A,2434,1)=chr$(val(mid$(date$,4,2)))  ' dd

'        If ucase$(mid$(XSubj,1,3))="MOD" and instr(ucase$(XSubj)," ADD")>0 then

  If XTitl="?~?" or XTitl="" then
    Z="Invalid or missing TITLe."
    gosub BadMaint: goto ECOEnd
  End if

  If XMod="?~?" or XMod="" then
    Z="Invalid or missing MODerator."
    gosub BadMaint: goto ECOEnd
  End if
'        End if

  Seek #1,((TRec*ELen)+1)
  Put$ #1,A
  TRec=TRec+1
  I=TRec
  TagTbl(I,1)=XTag
  TagTbl(I,2)=str$((((TRec-1)*ELen)+1))
  Z="==> Echo successfully ADDED."
  Goto NewEcho

ECOEnd:

  close #2, #3
WEnd  ' loop back for next ECO!

Goto EndItAll

MakeRul:

  XRule=XTag+".RUL"
  For LL=1 to len(XRule)-4
     CC=asc(mid$(XRule,LL,1))
     If (CC>47 and CC<58) or (CC>64 and CC<91) then  ' 0-9, A-Z ok
       Z4=""  ' dummy
      Else
       mid$(XRule,LL,1)="_"
     End if
  Next LL

  Z4="==> Rules file "+XRule+" Created <=="
  If isfile("Rules\"+XRule) then
    Z4="==> Rules file "+XRule+" Replaced <=="
  End if

  Open "Rules\"+XRule for output as #9
  M=M+1  ' skip RuleText keyword
  While M<=ECOCnt
    D=ECOTbl(M)
    If mid$(D,1,2)="---" then goto GotDash3  ' End of keywords
    If mid$(D,1,3)="-+-" then goto GotDash3  ' End of keywords
    Print #9,D
    M=M+1
  WEnd

GotDash3:
  Close #9
  Print #3,Z4: print #3
  Print #5,date$;" ";time$;" ";Z4
  M=M-1

Return

BuildIni:

Open "C:\Mystic\EListAll.INI" for output as #8

Print #8,"[General]"
Print #8,"Import_FIDONET.NA  = false"
Print #8,"Import_MessageBase = false"
Print #8,"Import_FILEBONE.NA = false"
Print #8,"Import_FILES.BBS   = false"
Print #8,"MassUpload         = false"
Print #8,"GenerateTopLists   = false"
Print #8,"GenerateAllFiles   = false"
Print #8,"PurgeMessageBases  = false"
Print #8,"PostTextFiles      = true"
Print #8,"PackMessageBases   = false"
Print #8,"ImportEchoMail     = false"
Print #8,"ExportEchoMail     = false"
Print #8,"MergeNodeLists     = false"
Print #8,"FileToss           = false"
Print #8,"PackFileBases      = false"
Print #8,"LinkMessages       = false"
Print #8,"mystic_directory=c:\mystic\mystic.dat"
Print #8,"logfile=mutil.log"
Print #8,"loglevel=2"
Print #8,"logtype = 0"
'Print #8,"maxlogfiles = 3"
'Print #8,"maxlogsize = 1000"
Print #8,"[PostTextFiles]"
Print #8,"totalfiles = 1"
If isfile("Beta.Flg") then
  Z1="348"
  Z2="BETABot"
  Print #8,"file1_name    = c:\elist.beta\elistupd.txt"
 else
  Print #8,"file1_name    = c:\elist\elistupd.txt"
End if
Print #8,"file1_baseidx = ";Z1
Print #8,"file1_from    = ";PgmVer;Z2

If PostMod="" then PostMod="All"
Print #8,"file1_to      = ";PostMod

Print #8,"file1_subj    = ";Z3
Print #8,"file1_addr    = 1:1/21"
Print #8,"file1_delfile = false"
Print #8,"; Generated by ";Pgmver;" on ";date$;" at ";time$

Close #8

 Return

DoUI:  ' Build XUser x148 from XUI

  X=XUI
  While XUI<>""
    If instr(XUI,",")>0 then
      X=mid$(XUI,1,instr(XUI,",")-1)
      XUI=mid$(XUI,instr(XUI,",")+1)
     Else
      X=XUI: XUI=""
    End if

    M=instr(X,"<"): P=instr(X,">")
    If instr(X,",")=0 and M>0 and P>0 then  ' NO comma, but <addy>
      Y=mid$(X,M+1,P-M-1)
      X="": if M>1 then X=mid$(X,1,M-1)
      Mid$(XUser,37,80)=Y+string$(80,0)
      Mid$(XUser,1,36)=X+string$(36,0)
      Goto NextUI
    End if

    If instr(X,":")>0 and instr(X,"/")>0 then  ' FIDO addy
      WZone=val(mid$(X,1))
      WNet=val(mid$(X,instr(X,":")+1))
      WNode=val(mid$(X,instr(X,"/")+1))
      If instr(X,".")>0 then WPoint=val(mid$(X,instr(X,".")+1)) else WPoint=0
      If instr(X,"@")>0 then WDomain=trim$(mid$(X,instr(X,"@")+1)) else WDomain=""
      Mid$(XUser,117,2)=mki$(WZone)
      Mid$(XUser,119,2)=mki$(WNet)
      Mid$(XUser,121,2)=mki$(WNode)
      Mid$(XUser,123,2)=mki$(WPoint)
      Mid$(XUser,125,24)=WDomain+string$(24,0)
      Goto NextUI
    End if

    If instr(X,"@")>0 then  ' Email addy
      Q=instr(X,"@")
      X=mid$(X,1,Q-1)+"{at}"+mid$(X,Q+1)
      Mid$(XUser,37,80)=X+string$(80,0)
      Goto NextUI
    End if

    If instr(X,":")=0 and instr(X,"/")=0 and instr(X,"@")=0 then  ' User Name
      Mid$(XUser,1,36)=trim$(X)+string$(36,0)
      Goto NextUI
    End if

NextUI:
  WEnd
Return

BadMaint:

Gosub SetEmail
If PvtEmail<>"" then print #3,"To: ";PvtEmail

Print #3,"==> *** Error: ";Z
Print #3
Print #3,"From: ";XFrom
Print #3
Print #3,"TAGname: ";XTag
Print #5,date$;" ";time$;" ";"==> *** Error: ";Z;" {";XTag;"} ";XFrom

'  L=1
'  Print #3
'  Print #3,"____________ Original Submission below ____________"
'  Print #3
'  While L<=ECOCnt
'    D=ECOTbl(L)
'    If instr(ucase$(D),"PASS") then
'      Print #3,"PASSword {masked}"
'     else
'      Print #3,D
'    End if
'    L=L+1
'  WEnd
'  Print #3,"= = = = = = = = = = = = = = = = = = = = = = = = = ="

PostUpd:
Open "elisthlp.txt" for input as #4
Print #3
While not eof(4)
  Line input#4,H
  Print #3,H
WEnd
Close #3, #4

'Print "Delay for 3 secs ..."
'Sleep 3000
'Q=Timer+3  ' Delay for MsgID
'While Timer<Q
'WEnd

If PvtEmail="" then goto EchoIt3

' EListUp.Bat arg 1 (%1) is TAGname,
'             arg 2 (%2) is Email addy,
'             arg 3 (%3) is Option (4)

Shell "cmd /c elistup.bat "+TagTbl(I,1)+" "+PvtEmail+" 4"

'Z="Cmd /c Imsend m "+chr$(34)+XTag  ' Reply via Email!
'Z=Z+" Echolist Update "+chr$(34)
'Z=Z+" 337:1/0 /t=elistupd.txt /o"+chr$(34)+"FIDONet EList v4 MaintBot"+chr$(34)
'Z=Z+" /a"+chr$(34)+"Internet Rex"+chr$(34)
'Shell Z

EchoIt3:

Z1="110": Z2="MaintBot": Z3=TagTbl(I,1)+" Echolist Update ERROR"
Gosub BuildIni

Shell "cmd /c elistup.bat NA NA 1"

Return

PostHelp:

Gosub SetEmail
If PvtEmail<>"" then print #3,"To: ";PvtEmail

Print #3,"==> *** Note - ";Z
Print #3
Print #3,"From: ";XFrom
Print #3
Print #5,date$;" ";time$;" ";"==> *** Note - ";Z;" ";XFrom
Goto PostUpd

SetEmail:

XUser=string$(148,0)  ' From
XUI=XFrom
Gosub DoUI

WEmail=trim$(mid$(XUser,37,80),chr$(0))
If WEmail<>"" then gosub DoPvtEm

Return

' MAINT option * * * * * * * * * * * * * * * * * * * * * * * * * * *

DoMaint:

Head1=PgmVer
Head2="FIDONet EchoList DataBase MAINTenance"
If isfile("Beta.Flg") then Head2=Head2+" BETA "
Head2=" -=:{ "+Head2+" }:=- "
Head3=PDate
Spacer1=space$(((132-len(Head2))/2)-len(Head1)-1)
Spacer2=space$(((132-len(Head2))/2)-len(Head3)-2)
Print #5,date$;" ";time$;" ";PgmVer;" ";Head2

Shell "cmd /c mode con cols=132 lines=58"
Console set screen 58,132

I=1

DoMMenu:

If I>TRec then I=1
Color 15,1
Cls: Print Head1;Spacer1;Head2;Spacer2;Head3: Print

For L=I to I+50

Print using$("####",L);" ";
Print TagTbl(L,1);" ";
Color 7
Print string$(37-len(TagTbl(L,1)),chr$(250));
Color 15
Print " ";TagTbl(L,3)
If L=TRec then L=I+50: EoTFlag=1

Next L

Print
Print "Enter Record # {X=eXit, Enter=Next Screen}: ";: input B
If ucase$(B)="X" then goto EndItAll

If B="" and I+50<=TRec then I=I+50: goto DoMMenu
If B="" then I=1: goto DoMMenu

If val(B)<1 or val(B)>TRec then beep: B="": goto DoMMenu

T=B

PlusRec:

Seek #1,val(TagTbl(val(T),2))
Get$ #1,ELen,A

DoMMenu2:

Cls: Print Head1;Spacer1;: Color 11: print Head2;: Color 15: print Spacer2;Head3: Print
  Color 11
  Print "A";: color 15: print " TAGname: ";: color 14: print trim$(mid$(A,2,36),chr$(0));
  WGrp=trim$(mid$(A,2267,16),chr$(0))
  Print "            ";: color 11: print "B";: color 15: print " GROUP: ";: color 14: print WGrp
  Print
  Print "  ";: color 11: print "Z";: color 15: print " PASSword: ";
   Color 12: print trim$(mid$(A,1975,36),chr$(0))
  Print
  WTitl=trim$(mid$(A,38,72),chr$(0))
  Print "  ";: color 11: print "C";: color 15: print " TITLe: ";
   Color 14: print WTitl
  Print

  WDesc=trim$(mid$(A,110,1125),chr$(0))
  If mid$(WDesc,1,1)=" " then WDesc=mid$(WDesc,2)
  Print "  ";: color 11: print "D";: color 15: print " DESCription:";: color 14

  J=len(WDesc): K=1: L=112
  If J<=L then Print " ";mid$(WDesc,1): goto NoDesc2

NextLine2:
  While L<>0 and mid$(WDesc,K+L-1,1)<>" "
    L=L-1
  WEnd
  If L=0 then goto NoDesc2

  Print " ";mid$(WDesc,K,L)

  K=K+L:L=124
  Print "   ";
  If K<J and J-K<L then goto LastDesc2
  If K<J then goto NextLine2

LastDesc2:
  Print " ";mid$(WDesc,K)

NoDesc2:
  Print

  WRule=trim$(mid$(A,2589,1500),chr$(0))
  If mid$(WRule,1,1)=" " then WRule=mid$(WRule,2)
  Print "  ";: color 11: print "6";: color 15: print " Rules:";: color 14

  J=len(WRule)
  K=instr(ucase$(WRule),".RUL")

  If K>1 and isfile("RULES\"+ucase$(WRule)) then  ' found .RUL file
    Print " ";WRule;: color 15: print " {Verified}": color 14
    Goto NoRule2
  End if
  If K>1 then  ' .RUL file missing
    Print " ";WRule;: color 15: print " {Not Found}": color 14
    Goto NoRule2
  End if

  K=1: L=120
  If J<=L then Print " ";WRule: goto NoRule2

NextRule2:
  While L<>0 and mid$(WRule,K+L-1,1)<>" "
    L=L-1
  WEnd
  If L=0 then goto NoRule2

  Print " ";mid$(WRule,K,L)

  K=K+L:L=124
  Print "   ";
  If K<J and J-K<L then goto LastRule2
  If K<J then goto NextRule2

LastRule2:
  Print " ";mid$(WRule,K)

NoRule2:

  Print
  Print "  ";: color 11: print "E";: color 15: print " MODerator: ";: color 14: print trim$(mid$(A,1235,36),chr$(0));
  WZone=cvi(A,1351)
  WNet=cvi(A,1353)
  WNode=cvi(A,1355)
  If WZone=0 or WNet=0 then print: goto SkipModNode2

  WPoint=cvi(A,1357)
  WDomain=trim$(mid$(A,1359,24),chr$(0))

  Print ", ";trim$(str$(WZone));
  Print ":";trim$(str$(WNet));
  Print "/";trim$(str$(WNode));
  If WPoint>0 or WDomain<>"" then 
    Print ".";trim$(str$(WPoint));
  End if
  If WDomain<>"" then Print "@";WDomain;
  Print

SkipModNode2:
  Print "      ";: color 11: print "F";: color 15: print " Email: ";: color 14: print trim$(mid$(A,1271,80),chr$(0))

  Print "  ";: color 11: print "G";: color 15: print " COMODerator: ";: color 14: print trim$(mid$(A,1383,36),chr$(0));
  WZone=cvi(A,1499)
  WNet=cvi(A,1501)
  WNode=cvi(A,1503)
  If WZone=0 or WNet=0 then print: goto SkipCModNode1B

  WPoint=cvi(A,1505)
  WDomain=trim$(mid$(A,1507,24),chr$(0))

  Print ", ";trim$(str$(WZone));
  Print ":";trim$(str$(WNet));
  Print "/";trim$(str$(WNode));
  If WPoint>0 or WDomain<>"" then 
    Print ".";trim$(str$(WPoint));
  End if
  If WDomain<>"" then Print "@";WDomain;
  Print

SkipCModNode1B:
  Print "      ";: color 11: print "H";: color 15: print " Email: ";: color 14: print trim$(mid$(A,1419,80),chr$(0))

NoCModNode1B:

  Print "  ";: color 11: print "I";: color 15: print " COMODerator: ";: color 14: print trim$(mid$(A,1531,36),chr$(0));
  WZone=cvi(A,1647)
  WNet=cvi(A,1649)
  WNode=cvi(A,1651)
  If WZone=0 or WNet=0 then print: goto SkipCModNode2B

  WPoint=cvi(A,1653)
  WDomain=trim$(mid$(A,1655,24),chr$(0))

  Print ", ";trim$(str$(WZone));
  Print ":";trim$(str$(WNet));
  Print "/";trim$(str$(WNode));
  If WPoint>0 or WDomain<>"" then 
    Print ".";trim$(str$(WPoint));
  End if
  If WDomain<>"" then Print "@";WDomain;
  Print

SkipCModNode2B:
  Print "      ";: color 11: print "J";: color 15: print " Email: ";: color 14: print trim$(mid$(A,1567,80),chr$(0))

NoCModNode2B:

  Print "  ";: color 11: print "K";: color 15: print " COMODerator: ";: color 14: print trim$(mid$(A,1679,36),chr$(0));
  WZone=cvi(A,1795)
  WNet=cvi(A,1797)
  WNode=cvi(A,1799)
  If WZone=0 or WNet=0 then print: goto SkipCModNode3B

  WPoint=cvi(A,1801)
  WDomain=trim$(mid$(A,1803,24),chr$(0))

  Print ", ";trim$(str$(WZone));
  Print ":";trim$(str$(WNet));
  Print "/";trim$(str$(WNode));
  If WPoint>0 or WDomain<>"" then 
    Print ".";trim$(str$(WPoint));
  End if
  If WDomain<>"" then Print "@";WDomain;
  Print

SkipCModNode3B:
  Print "      ";: color 11: print "L";: color 15: print " Email: ";: color 14: print trim$(mid$(A,1715,80),chr$(0))

NoCModNode3B:

  Print "  ";: color 11: print "M";: color 15: print " COMODerator: ";: color 14: print trim$(mid$(A,1827,36),chr$(0));
  WZone=cvi(A,1943)
  WNet=cvi(A,1945)
  WNode=cvi(A,1947)
  If WZone=0 or WNet=0 then print: goto SkipCModNode4B

  WPoint=cvi(A,1949)
  WDomain=trim$(mid$(A,1951,24),chr$(0))

  Print ", ";trim$(str$(WZone));
  Print ":";trim$(str$(WNet));
  Print "/";trim$(str$(WNode));
  If WPoint>0 or WDomain<>"" then 
    Print ".";trim$(str$(WPoint));
  End if
  If WDomain<>"" then Print "@";WDomain;
  Print

SkipCModNode4B:
  Print "      ";: color 11: print "N";: color 15: print " Email: ";: color 14: print trim$(mid$(A,1863,80),chr$(0))

NoCModNode4B:

  Print
  WVol=cvl(A,2011)
  Print "  ";: color 11: print "O";: color 15: print " VOLume: ";: color 14: print trim$(str$(WVol))  ' /month

  WOrig=trim$(mid$(A,2087,36),chr$(0))
  Print "  ";: color 11: print "P";: color 15: print " ORIGin: ";: color 14: print WOrig;
  If WVol>0 or WOrig<>"" then print: 'print

  WRest=trim$(mid$(A,2015,72),chr$(0))
  If WRest<>"" then 
    Print "  ";: color 11: print "Q";: color 15: print " RESTrictions: ";: color 14: print WRest
   Else
    Print "  ";: color 11: print "Q";: color 15: print " RESTrictions: {None}"
  End if

  WDist=trim$(mid$(A,2123,72),chr$(0))
  If WDist<>"" then
    Print "  ";: color 11: print "R";: color 15: print " DISTribution: ";: color 14: print WDist
   Else
    Print "  ";: color 11: print "R";: color 15: print " DISTribution: {N/A}"
  End if

  WGate=trim$(mid$(A,2195,72),chr$(0))
  Print "  ";: color 11: print "S";: color 15: print " GATEway: ";: color 14: print WGate
  Print

  WMess=trim$(mid$(A,2283,36),chr$(0))
  Print "  ";: color 11: print "T";: color 15: print " From : ";: color 14: print WMess;
  WZone=cvi(A,2399)
  WNet=cvi(A,2401)
  WNode=cvi(A,2403)
  If WZone=0 or WNet=0 then goto SkipMessNode2

  WPoint=cvi(A,2405)
  WDomain=trim$(mid$(A,2407,24),chr$(0))

  Print ", ";trim$(str$(WZone));
  Print ":";trim$(str$(WNet));
  Print "/";trim$(str$(WNode));
  If WPoint>0 or WDomain<>"" then 
    Print ".";trim$(str$(WPoint));
  End if
  If WDomain<>"" then Print "@";WDomain;

SkipMessNode2:
  Print
  Print "      ";: color 11: print "U";: color 15: print " Email: ";: color 14: print trim$(mid$(A,2319,80),chr$(0))

  WUpd=trim$(str$(cvwrd(A,2435)))
  Print
  Print "  ";: color 11: print "V";: color 15: print " Updated on ";: color 14: print trim$(str$(cvbyt(A,2437)));"/";
  Print trim$(str$(cvbyt(A,2438)));"/";WUpd
  Print
  WReply=trim$(mid$(A,2441,36),chr$(0))
  Print "  ";: color 11: print "2";: color 15: print " Reply-to : ";: color 14: print WReply;
  WZone=cvi(A,2557)
  WNet=cvi(A,2559)
  WNode=cvi(A,2561)
  If WZone=0 or WNet=0 then goto SkipReplyNode

  WPoint=cvi(A,2563)
  WDomain=trim$(mid$(A,2565,24),chr$(0))

  Print ", ";trim$(str$(WZone));
  Print ":";trim$(str$(WNet));
  Print "/";trim$(str$(WNode));
  If WPoint>0 or WDomain<>"" then 
    Print ".";trim$(str$(WPoint));
  End if
  If WDomain<>"" then Print "@";WDomain;

SkipReplyNode:
  Print
  Print "      ";: color 11: print "3";: color 15: print " Email: ";: color 14: print trim$(mid$(A,2477,80),chr$(0))

  Print
  Print "  ";: color 11: print "W";: color 15: print " Warnings: ";: color 14: print cvbyt(mid$(A,2439,1));
  Print "    ";: color 11: print "Y";: color 15: print " Status: ";: color 14: print cvbyt(mid$(A,2440,1));
  If cvbyt(A,2440)=0 then print " = {Active}";
  If cvbyt(A,2440)=1 then print " = {Pending Deletion}";
  WUpd=trim$(str$(cvwrd(A,2431)))
  Print "     ";: color 11: print "4";: color 15: print " Created on ";: color 14: print trim$(str$(cvbyt(A,2433)));"/";
  Print trim$(str$(cvbyt(A,2434)));"/";WUpd

GetField:
Color 15: Print
Print "Select ";: color 11: print "Field";: color 15: print " to change {";
Color 11: print "A";: color 15: print "-";
Color 11: print "Z";: color 15: print ", ";: color 11: print "0";
Color 15: print "-";: color 11: print "9";: color 15: print ", ";
Color 11: print "+";: color 15: print "=Next ";: color 11: print "-";
Color 15: print "=Prev ";: color 11: print "X";: color 15: print "=eXit}: ";

GetFieldKey:
B=""
Cursor OFF
While B=""
 If Instat=0 then Sleep 25 else B=Inkey$: BitShift=INSHIFT
WEnd
Cursor ON, 100
Print: Print

B=ucase$(B)
If B="" then goto DoMMenu
If B="X" or B=chr$(27) or B=chr$(13) then goto DoMMenu
If B="-" or B="_" then goto ChkMaint
If B="+" or B="=" then goto ChkMaint

If instr("ABCDEFGHIJKLMNOPQRSTUVWYZ2346",B)=0 then
  beep: beep
  goto GetFieldKey
End if

If B="E" then gosub GetNode: goto ChkMaint  ' Node strings
If B="G" then gosub GetNode: goto ChkMaint
If B="I" then gosub GetNode: goto ChkMaint
If B="K" then gosub GetNode: goto ChkMaint
If B="M" then gosub GetNode: goto ChkMaint
If B="T" then gosub GetNode: goto ChkMaint
If B="2" then gosub GetNode: goto ChkMaint

If B="C" then  ' Title x72
  Locate 50,1: CY=CursorY
  Print space$(TCol*3);
  Locate CY+1,1
  CX=CURSORX: CY=CURSORY
  buffer=WTitl+space$(72-len(WTitl))
 retVal = TextInput(TCol, CurFile, buffer, CY, CX, history1())
  C=Trim$(buffer): Color 15,1
  If C="" then goto DoMMenu2 else goto ChkMaint
End if

If B="D" then  ' Description x 1125
  Locate 47,1: CY=CursorY
  Print space$(TCol*11);
  Locate CY+1,1
  CX=CURSORX: CY=CURSORY
  buffer=WDesc+space$(1125-len(WDesc))
 retVal = TextInput(TCol, CurFile, buffer, CY, CX, history1())
  C=Trim$(buffer): Color 15,1
  If C="" then goto DoMMenu2 else goto ChkMaint
End if

If B="6" then  ' Rules x 1500
  Locate 44,1: CY=CursorY
  Print space$(TCol*15);
  Locate CY+1,1
  CX=CURSORX: CY=CURSORY
  buffer=WRule+space$(1500-len(WRule))
 retVal = TextInput(TCol, CurFile, buffer, CY, CX, history1())
  C=Trim$(buffer): Color 15,1
  If C="" then goto DoMMenu2 else goto ChkMaint
End if

If B="V" or B="4" then
  Gosub GetDate
  If C="" or C="X" then goto DoMMenu2
  Goto ChkMaint
End if

If B="W" then
  Gosub GetWarn
  If C="" or C="X" then goto DoMMenu2
  Goto ChkMaint
End if

If B="Y" then
  Gosub GetStat
  If C="" or C="X" then goto DoMMenu2
  Goto ChkMaint
End if

If B="O" then
  Gosub GetVol
  If C="" or C="X" then goto DoMMenu2
  Goto ChkMaint
End if

Print "Option [";B;"] ": print
Print "Enter NEW text (X=eXit) : ";: line input C  ' Plain Text fields
If ucase$(C)="X" then goto DoMMenu2

If B="A" then
  Print "Do you wish to *ADD* TAGname: ";ucase$(C);" {Y/N} ? ";:input B
  B=ucase$(B)
  If B<>"Y" goto ChkMaint

  A=chr$(4)+string$(ELen-1,chr$(0))
  mid$(A,2,36)=ucase$(C)+string$(36,chr$(0))
  Seek #1,((TRec*ELen)+1)
  Put$ #1,A
  Close #1: goto StartUp
End if

ChkMaint:

If ucase$(C)="X" then goto DoMMenu2

If B="+" or B="=" then
  If val(T)=TRec then T="1" else T=trim$(str$(val(T)+1))
  Goto PlusRec
End if
If B="-" or B="_" then
  If val(T)=1 then T=trim$(str$(TRec)) else T=trim$(str$(val(T)-1))
  Goto PlusRec
End if

If B="A" then mid$(A,2,36)=ucase$(C)+string$(36,chr$(0))
If B="B" then mid$(A,2267,16)=C+string$(16,chr$(0))
If B="C" then mid$(A,38,72)=C+string$(72,chr$(0))
If B="D" then mid$(A,110,1125)=C+string$(1125,chr$(0))
If B="6" then mid$(A,2589,1500)=C+string$(1500,chr$(0))
If B="E" then mid$(A,1235,148)=XUser
If B="F" then gosub FixEmail: mid$(A,1271,80)=C+string$(80,chr$(0))
If B="G" then mid$(A,1383,148)=XUser
If B="H" then gosub FixEmail: mid$(A,1419,80)=C+string$(80,chr$(0))
If B="I" then mid$(A,1531,148)=XUser
If B="J" then gosub FixEmail: mid$(A,1567,80)=C+string$(80,chr$(0))
If B="K" then mid$(A,1679,148)=XUser
If B="L" then gosub FixEmail: mid$(A,1715,80)=C+string$(80,chr$(0))
If B="M" then mid$(A,1827,148)=XUser
If B="N" then gosub FixEmail: mid$(A,1863,80)=C+string$(80,chr$(0))
If B="O" then mid$(A,2011,4)=mkl$(val(C))
If B="P" then mid$(A,2087,36)=C+string$(36,chr$(0))
If B="Q" then mid$(A,2015,72)=C+string$(72,chr$(0))
If B="R" then mid$(A,2123,72)=C+string$(72,chr$(0))
If B="S" then mid$(A,2195,72)=C+string$(72,chr$(0))
If B="T" then mid$(A,2283,148)=XUser
If B="U" then gosub FixEmail: mid$(A,2319,80)=C+string$(80,chr$(0))

If B="V" then  ' V Date Updated @ 2435 x4 yyyymmdd
  mid$(A,2435,2)=Mkl$(WYyyy)
  mid$(A,2437,1)=Mkbyt$(WMm)
  mid$(A,2438,1)=Mkbyt$(WDd)
End if

If B="2" then mid$(A,2441,148)=XUser
If B="3" then gosub FixEmail: mid$(A,2477,80)=C+string$(80,chr$(0))
If B="W" then mid$(A,2439,1)=mkbyt$(val(C))

If B="4" then  ' 4 Date Created @ 2431 x4 yyyymmdd
  mid$(A,2431,2)=Mkl$(WYyyy)
  mid$(A,2433,1)=Mkbyt$(WMm)
  mid$(A,2434,1)=Mkbyt$(WDd)
End if

If B ="Y" then mid$(A,2440,1)=mkbyt$(val(C))
If B="Z" then mid$(A,1975,36)=C+string$(36,chr$(0))

Seek #1,val(TagTbl(val(T),2))
Put$ #1,A

Goto DoMMenu2

Goto EndItAll

GetVol:
  Print "Enter message Volume {n/Month or X=eXit} : ";: line input C
  C=ucase$(C)
  If C="" then beep: return
  If C="X" then return
  If val(C)<0 then beep: beep: goto GetVol

 Return

GetWarn:
  Print "Enter Warning count {0-3 or X=eXit} : ";: line input C
  C=ucase$(C)
  If C="" then beep: return
  If C="X" then return
  If val(C)<0 or val(C)>3 then beep: beep: goto GetWarn

 Return

GetStat:
  Print "Enter Status {0=Active, 1=Pending Deletion or X=eXit} : ";: line input C
  C=ucase$(C)
  If C="" then beep: return
  If C="X" then return
  If val(C)<0 or val(C)>1 then beep: beep: goto GetStat

 Return

GetDate:

  Print "Enter Date {mm/dd/yyyy or X=eXit} : ";: line input C
  C=ucase$(C)
  If C="" then beep: return
  If C="X" then return
' Check for second slash
  If instr(mid$(C,instr(C,"/")+1),"/")=0 then Beep: Beep: goto GetDate
' Check for valid year
  If val(right$(C,4))<2000 then Beep: Beep: goto GetDate

  WMm=val(C)
  WDd=val(mid$(C,instr(C,"/")+1))
  WYyyy=val(right$(C,4))

' Validate mm dd and yyyy again
  If WMm<1 or WMm>12 or WDd<1 or WDd>31 or WYyyy>val(right$(date$,4)) then
    Beep: Beep: goto GetDate
  End if

 Return

GetNode:

  Print "Enter Node string {Full Name, FIDO Addy, Email} or X=eXit : ": line input C
  If ucase$(C)="X" then return
  XUser=string$(148,0)
  XUI=C
  Gosub DoUI

 Return

FixEmail:
  If instr(C,"@")>0 then  ' Email addy @ to {at}
    Q=instr(C,"@")
    C=mid$(C,1,Q-1)+"{at}"+mid$(C,Q+1)
  End if
 Return

' REPORT option * * * * * * * * * * * * * * * * * * * * * * * * * * *

DoReport:

Head1=PgmVer
Head2="FIDONet EchoList Database Report"
If isfile("Beta.Flg") then Head2="FIDONet EchoList BETA Database Report"
Spacer1=space$(((80-len(Head2))/2)-len(PgmVer))
Spacer2=space$((80-len(PDate))/2)

Open "EList.Rpt" for output as #3
Open "EList.NA" for output as #4

Print #3,Head1;Spacer1;Head2
Print #3
Print #3,Spacer2;PDate
Print #3
Print #5,date$;" ";time$;" ";Head1;" ";Head2

I=1
While I<=TRec
  Seek #1,val(TagTbl(I,2))
  Get$ #1,ELen,A
  If cvbyt(mid$(A,2440,1))=1 then goto SkipPD  ' skip Pending Deletes

  Print #3,string$(79,"_")
  Print #3

JumpRpt:
  Print #3,"TAGname: ";trim$(mid$(A,2,36),chr$(0));
  If RFlag=0 then Print #4,trim$(mid$(A,2,36),chr$(0));space$(38-len(trim$(mid$(A,2,36),chr$(0))));
  WGrp=trim$(mid$(A,2267,16),chr$(0))
  If WGrp<>"" then print #3,space$(44-len(trim$(mid$(A,2,36),chr$(0))));" GROUP: ";WGrp;
  Print #3

  Print #3
  Print #3,"  TITLe: ";trim$(mid$(A,38,72),chr$(0))
  If RFlag=0 then Print #4,trim$(mid$(A,38,72),chr$(0))
  Print #3

  WDesc=trim$(mid$(A,110,1125),chr$(0))  ' Do Description x 1125
  If WDesc="" then goto NoDesc
  If mid$(WDesc,1,1)=" " then WDesc=mid$(WDesc,2)
  Print #3,"  DESCription:";

  J=len(WDesc): K=1: L=61
  If J<62 then Print #3," ";mid$(WDesc,1): goto NoDesc

NextLine:
  While L<>0 and mid$(WDesc,K+L-1,1)<>" "
    L=L-1
  WEnd
  If L=0 then goto NoDesc

  Print #3," ";mid$(WDesc,K,L)

  K=K+L:L=75
  Print #3,"   ";
  If K<J and J-K<L then goto LastDesc
  If K<J then goto NextLine

LastDesc:
  Print #3," ";mid$(WDesc,K)

NoDesc:
  If WDesc<>"" then print #3

  WRule=trim$(mid$(A,2589,1500),chr$(0))  ' Do Rules x 1500
  If mid$(WRule,1,1)=" " then WRule=mid$(WRule,2)
  If WRule="" then goto NoRule

  Print #3,"  RULEs:";
  J=len(WRule)
  K=instr(ucase$(WRule),".RUL")

  If K>1 and isfile("RULES\"+ucase$(WRule)) then  ' found .RUL file
    Print #3," ";WRule;" {Verified}"
    Goto NoRule
  End if
  If K>1 then  ' .RUL file missing
    Print #3," ";WRule;" {Not Found}"
    Goto NoRule
  End if

  K=1: L=61
  If J<62 then Print #3," ";WRule: goto NoRule

NextRule:
  While L<>0 and mid$(WRule,K+L-1,1)<>" "
    L=L-1
  WEnd
  If L=0 then goto NoRule

  Print #3," ";mid$(WRule,K,L)

  K=K+L:L=75
  Print #3,"   ";
  If K<J and J-K<L then goto LastRule
  If K<J then goto NextRule

LastRule:
  Print #3," ";mid$(WRule,K)

NoRule:
  If WRule<>"" then print #3

  Print #3,"  MODerator:    ";trim$(mid$(A,1235,36),chr$(0));
  PostMod=trim$(mid$(A,1235,36),chr$(0))
  If instr(PostMod,",")>0 then 
    PostMod=mid$(PostMod,1,instr(PostMod,",")-1)
  End if

  WZone=cvi(A,1351)
  WNet=cvi(A,1353)
  WNode=cvi(A,1355)
  If WZone=0 or WNet=0 then print #3: goto SkipModNode

  WPoint=cvi(A,1357)
  WDomain=trim$(mid$(A,1359,24),chr$(0))

  Print #3,", ";trim$(str$(WZone));
  Print #3,":";trim$(str$(WNet));
  Print #3,"/";trim$(str$(WNode));
  If WPoint>0 or WDomain<>"" then 
    Print #3,".";trim$(str$(WPoint));
  End if
  If WDomain<>"" then Print #3,"@";WDomain;
  Print #3

SkipModNode:
  If trim$(mid$(A,1271,80),chr$(0))<>"" then
    Print #3,"      Email:    ";trim$(mid$(A,1271,80),chr$(0))
  End if

  If trim$(mid$(A,1383,36),chr$(0))="" then goto NoCModNode1
  Print #3,"  COMODerator:  ";trim$(mid$(A,1383,36),chr$(0));
  WZone=cvi(A,1499)
  WNet=cvi(A,1501)
  WNode=cvi(A,1503)
  If WZone=0 or WNet=0 then print #3: goto SkipCModNode1

  WPoint=cvi(A,1505)
  WDomain=trim$(mid$(A,1507,24),chr$(0))

  Print #3,", ";trim$(str$(WZone));
  Print #3,":";trim$(str$(WNet));
  Print #3,"/";trim$(str$(WNode));
  If WPoint>0 or WDomain<>"" then 
    Print #3,".";trim$(str$(WPoint));
  End if
  If WDomain<>"" then Print #3,"@";WDomain;
  Print #3

SkipCModNode1:
  If trim$(mid$(A,1419,80),chr$(0))<>"" then
    Print #3,"      Email:    ";trim$(mid$(A,1419,80),chr$(0))
  End if

NoCModNode1:

  If trim$(mid$(A,1531,36),chr$(0))="" then goto NoCModNode2
  Print #3,"  COMODerator:  ";trim$(mid$(A,1531,36),chr$(0));
  WZone=cvi(A,1647)
  WNet=cvi(A,1649)
  WNode=cvi(A,1651)
  If WZone=0 or WNet=0 then print #3: goto SkipCModNode2

  WPoint=cvi(A,1653)
  WDomain=trim$(mid$(A,1655,24),chr$(0))

  Print #3,", ";trim$(str$(WZone));
  Print #3,":";trim$(str$(WNet));
  Print #3,"/";trim$(str$(WNode));
  If WPoint>0 or WDomain<>"" then 
    Print #3,".";trim$(str$(WPoint));
  End if
  If WDomain<>"" then Print #3,"@";WDomain;
  Print #3

SkipCModNode2:
  If trim$(mid$(A,1567,80),chr$(0))<>"" then
    Print #3,"      Email:    ";trim$(mid$(A,1567,80),chr$(0))
  End if

NoCModNode2:

  If trim$(mid$(A,1679,36),chr$(0))="" then goto NoCModNode3
  Print #3,"  COMODerator:  ";trim$(mid$(A,1679,36),chr$(0));
  WZone=cvi(A,1795)
  WNet=cvi(A,1797)
  WNode=cvi(A,1799)
  If WZone=0 or WNet=0 then print #3: goto SkipCModNode3

  WPoint=cvi(A,1801)
  WDomain=trim$(mid$(A,1803,24),chr$(0))

  Print #3,", ";trim$(str$(WZone));
  Print #3,":";trim$(str$(WNet));
  Print #3,"/";trim$(str$(WNode));
  If WPoint>0 or WDomain<>"" then 
    Print #3,".";trim$(str$(WPoint));
  End if
  If WDomain<>"" then Print #3,"@";WDomain;
  Print #3

SkipCModNode3:
  If trim$(mid$(A,1715,80),chr$(0))<>"" then
    Print #3,"      Email:    ";trim$(mid$(A,1715,80),chr$(0))
  End if

NoCModNode3:

  If trim$(mid$(A,1827,36),chr$(0))="" then goto NoCModNode4
  Print #3,"  COMODerator:  ";trim$(mid$(A,1827,36),chr$(0));
  WZone=cvi(A,1943)
  WNet=cvi(A,1945)
  WNode=cvi(A,1947)
  If WZone=0 or WNet=0 then print #3: goto SkipCModNode4

  WPoint=cvi(A,1949)
  WDomain=trim$(mid$(A,1951,24),chr$(0))

  Print #3,", ";trim$(str$(WZone));
  Print #3,":";trim$(str$(WNet));
  Print #3,"/";trim$(str$(WNode));
  If WPoint>0 or WDomain<>"" then 
    Print #3,".";trim$(str$(WPoint));
  End if
  If WDomain<>"" then Print #3,"@";WDomain;
  Print #3

SkipCModNode4:
  If trim$(mid$(A,1863,80),chr$(0))<>"" then
    Print #3,"      Email:    ";trim$(mid$(A,1863,80),chr$(0))
  End if

NoCModNode4:

  Print #3
  WVol=cvl(A,2011)
  If WVol>0 then Print #3,"  VOLume:       ";trim$(str$(WVol));"/month"

  WOrig=trim$(mid$(A,2087,36),chr$(0))
  If WOrig<>"" then
    If WVol>0 then Print #3
    Print #3,"  ORIGin:       ";WOrig
  End if
  If WVol>0 or WOrig<>"" then print #3

  WRest=trim$(mid$(A,2015,72),chr$(0))
  If WRest<>"" and (ucase$(WRest)="/REAL" or ucase$(WRest)="/REA") then
    Print #3,"  RESTrictions: ";WRest;" {REAL Names ONLY}";
   Elseif WRest<>"" then
    Print #3,"  RESTrictions: ";WRest;
    if instr(ucase$(WRest),"/REA")>0 then print #3," {REAL Names ONLY}";
    if instr(ucase$(WRest),"/SYS")>0 then print #3," {SysOps ONLY}";
   Elseif WRest="" then
    Print #3,"  RESTrictions: {None on record}";
  End if
  Print #3

  Print #3
  WDist=trim$(mid$(A,2123,72),chr$(0))
  If WDist<>"" then
    Print #3,"  DISTribution: ";WDist
   Else
    Print #3,"  DISTribution: {N/A}"
  End if

  WGate=trim$(mid$(A,2195,72),chr$(0))
  If WGate<>"" then print #3: print #3,"  GATEway:      ";WGate

  Print #3

  WReply=trim$(mid$(A,2441,36),chr$(0))
  WZone=cvi(A,2557)
  WNet=cvi(A,2559)
  WNode=cvi(A,2561)
  If WReply="" and (WZone=0 or WNet=0) and trim$(mid$(A,2477,80),chr$(0))="" then goto SkipReplyAll

  Print #3,"  Reply-to:     ";WReply;

  If WZone=0 or WNet=0 then goto SkipReplyNode2

  WPoint=cvi(A,2563)
  WDomain=trim$(mid$(A,2565,24),chr$(0))

  Print #3,", ";trim$(str$(WZone));
  Print #3,":";trim$(str$(WNet));
  Print #3,"/";trim$(str$(WNode));
  If WPoint>0 or WDomain<>"" then 
    Print #3,".";trim$(str$(WPoint));
  End if
  If WDomain<>"" then Print #3,"@";WDomain;
  Print #3

SkipReplyNode2:
  Print #3
  If trim$(mid$(A,2477,80),chr$(0))<>"" then
    Print #3,"      Email:    ";trim$(mid$(A,2477,80),chr$(0))
  End if
  Print #3

SkipReplyAll:
  WMess=trim$(mid$(A,2283,36),chr$(0))
  Print #3,"  From:         ";WMess;
  WZone=cvi(A,2399)
  WNet=cvi(A,2401)
  WNode=cvi(A,2403)
  If WZone=0 or WNet=0 then goto SkipMessNode

  WPoint=cvi(A,2405)
  WDomain=trim$(mid$(A,2407,24),chr$(0))

  Print #3,", ";trim$(str$(WZone));
  Print #3,":";trim$(str$(WNet));
  Print #3,"/";trim$(str$(WNode));
  If WPoint>0 or WDomain<>"" then 
    Print #3,".";trim$(str$(WPoint));
  End if
  If WDomain<>"" then Print #3,"@";WDomain;

SkipMessNode:

  Print #3
  If trim$(mid$(A,2319,80),chr$(0))<>"" then
    Print #3,"      Email:    ";trim$(mid$(A,2319,80),chr$(0))
  End if

  WUpd=trim$(str$(cvwrd(A,2435)))
  If Wupd="" then goto NoUpd
  Print #3: print #3,"  Updated on:   ";trim$(str$(cvbyt(A,2437)));"/";
  Print #3,trim$(str$(cvbyt(A,2438)));"/";WUpd

NoUpd:

  If RFlag=1 then  ' only do one area
    Print #3: Print #3,space$(28);"-=:{ End of Report }:=- "
    return
  End if

SkipPD:
  I=I+1
Wend

  Print #3
  Print #3,string$(79,"_")
  Tail1=" { "+trim$(str$(TRec))+" records reported }"
  Print #3,space$((80-len(Tail1))/2);Tail1
  Print #5,date$;" ";time$;" ";Tail1

Goto EndItAll

EndItAll:
Close
If isfile("\EListBsy.Flg") then kill "\EListBsy.Flg"

RC=ERR
End RC

REM Month Table Data
DATA January, February, March, April, May, June
DATA July, August, September, October, November, December

END FUNCTION

' TextInput function (c) 2005 Geo Massar with mods by Ben Ritchey

FUNCTION TextInput(TCol as Long, CurFile AS STRING, Buffer AS STRING, _
              Row AS LONG, Col AS LONG, History() AS STRING) AS LONG
  STATIC InsertOff    AS LONG
  LOCAL  BufferLen    AS LONG
  LOCAL  MyKey        AS STRING
  LOCAL  KeyVal       AS LONG
  LOCAL  ColorDefault AS BYTE
  LOCAL  CurPos       AS LONG
  LOCAL  HistoryIdx   AS LONG
  Local A, Z as String
  Local M, AA, CX, CY as Long

  BufferLen = LEN(Buffer)
  HistoryIdx = UBOUND(History)                 'index to the empty slot
  ColorDefault = SCREENATTR(CURSORY,CURSORX)
  LOCATE Row, Col : COLOR 0, 7, BufferLen     'bright white against dark blue
  If mid$(Buffer,1,1)<>" " then
    PRINT String$(BufferLen+1,chr$(249));
    LOCATE Row, Col: print mid$(buffer,1);
    CurPos=1: LOCATE Row, Col
   else
    PRINT String$(BufferLen+1,chr$(249));
    CurPos=1: LOCATE Row, Col
  End if

  DO
    MyKey=""
    While MyKey=""
     If Instat=0 then Sleep 50 else MyKey=Inkey$
    WEnd

    SELECT CASE LEN(MyKey)
      CASE 1    : KeyVal = ASC(MyKey)
      CASE 2    : KeyVal = - ASC(MyKey, 2)
      CASE ELSE : ITERATE
    END SELECT

    SELECT CASE KeyVal

      CASE 13  'Enter
        COLOR ColorDefault MOD 16, ColorDefault \ 16
        FUNCTION = KeyVal
        IF TRIM$(Buffer) = "" THEN EXIT FUNCTION
        HistoryIdx = UBOUND(History)
        IF HistoryIdx > 0 THEN IF Buffer = History(HistoryIdx-1) THEN EXIT FUNCTION
        History(HistoryIdx) = Buffer
        INCR HistoryIdx
        REDIM PRESERVE History(HistoryIdx)
        History(HistoryIdx) = SPACE$(BufferLen)  'new slot for the next entry
        EXIT FUNCTION

      CASE 27  ' ESCape
        If CurPos=1 then 
          If Buffer="" then Exit Function
          LOCATE Row, Col
          PRINT Space$(Len(Buffer));
          Buffer=""
         else
          CurPos=1
        End if

      CASE -72  'Up
        If CurPos>TCol then
          Locate CursorY-1
          CurPos=CurPos-TCol
        End if

      CASE -80  'Down
        If CurPos+TCol<BufferLen then
          Locate CursorY+1
          CurPos=CurPos+TCol
        End if

      CASE -82 'Insert
       IF InsertOff THEN
         InsertOff = 0
         CURSOR ON, 1
       ELSE
         InsertOff = 1
         CURSOR ON, 100
       END IF

      CASE 8 'BackSpace
       IF CurPos > 1 THEN
         DECR CurPos
         Buffer = LEFT$(Buffer, CurPos - 1) & MID$(Buffer, CurPos + 1) & " "
       END IF

      CASE -75 'Left
       IF CurPos > 1 THEN DECR CurPos

      CASE -77 'Right
       IF CurPos < BufferLen THEN INCR CurPos

      CASE 9  ' Tab
       IF CurPos+10 < BufferLen THEN CurPos=CurPos+10

      CASE -71 'Home
       CurPos = 1

      CASE -79 'End
       CurPos = MIN(LEN(RTRIM$(Buffer)) + 1, BufferLen)

      CASE -83 'Del
       Buffer = LEFT$(Buffer, CurPos - 1) & MID$(Buffer, CurPos + 1) & " "

'      CASE -38 'Alt+L = LFN Insert
'       IF len(CurFile) > 52 and mid$(CurFile, 53, 1) <> " " then  ' Extract LFN
'         MyKey = mid$(CurFile, 53)
'        ELSE
'         MyKey=""
'       END IF
'       Buffer = LEFT$(Buffer, CurPos - 1) & chr$(34) & MyKey & chr$(34) _
'                  & " " & MID$(Buffer, CurPos, BufferLen - CurPos)
'       CurPos = CurPos + len(MyKey) + 3

      CASE 32 TO 255 'Valid charaters
       IF InsertOff THEN
         MID$(Buffer, CurPos, 1) = MyKey
       ELSE
         Buffer = LEFT$(Buffer, CurPos - 1) & MyKey & MID$(Buffer, CurPos, BufferLen - CurPos)
       END IF
       IF CurPos < BufferLen THEN INCR CurPos

      CASE ELSE
       ITERATE
    END SELECT

'    Locate 58,1: print "CurPos: ";CurPos;"  BufferLen: ";bufferlen;
    LOCATE Row, Col
    PRINT Buffer;
    LOCATE Row, Col
    If CurPos>len(rtrim$(buffer))+2 then CurPos=MIN(LEN(RTRIM$(Buffer))+1,BufferLen)
    M=CurPos
    While M>TCol
      Locate CursorY+1: M=M-TCol
    Wend
    LOCATE ,M
  LOOP

DOTOD:
  CX=CURSORX: CY=CURSORY
  Z=TIME$: AA=VAL(MID$(TIME$, 1, 2))
  IF AA>11 THEN Z=Z+" Pm" ELSE Z=Z+" Am"
  IF AA>12 THEN
    A=MID$(STR$(AA-12),2)
    IF LEN(A)=1 THEN A=" "+A
    MID$(Z,1)=A: A=""
  END IF
  Cursor OFF
  Locate 1,(TCol-13): Color 0,7: PRINT " ";Z;"  ";: Z=""
  LOCATE CY,CX
  Cursor ON, 100
  Color 7,1
 RETURN

END FUNCTION

' EList.DB format:

' Loc   Length   Type  Label
' ----- -------- ----- --------------------------------------------------
'    1      1    Bin   Version '41'
'    2     36    Text  TAGname
'   38     72     "    TITLe
'  110   1125     "    DESCription (15 lines x75)
'
' 1235     36    Text  MODerator Name 
' 1271     80     "     "  Email address
' 1351      2    UInt   "  Zone
' 1353      2     "     "  Net
' 1355      2     "     "  Node
' 1357      2     "     "  Point
' 1359     24    Text   "  Domain
'
' 1383     36    Text  COMODerator 1 Name 
' 1419     80     "     "  Email address
' 1499      2    UInt   "  Zone
' 1501      2     "     "  Net
' 1503      2     "     "  Node
' 1505      2     "     "  Point
' 1507     24    Text   "  Domain
'
' 1531     36    Text  COMODerator 2 Name 
' 1567     80     "     "  Email address
' 1647      2    UInt   "  Zone
' 1649      2     "     "  Net
' 1651      2     "     "  Node
' 1653      2     "     "  Point
' 1655     24    Text   "  Domain
'
' 1679     36    Text  COMODerator 3 Name 
' 1715     80     "     "  Email address
' 1795      2    UInt   "  Zone
' 1797      2     "     "  Net
' 1799      2     "     "  Node
' 1801      2     "     "  Point
' 1803     24    Text   "  Domain
'
' 1827     36    Text  COMODerator 4 Name 
' 1863     80     "     "  Email address
' 1943      2    UInt   "  Zone
' 1945      2     "     "  Net
' 1947      2     "     "  Node
' 1949      2     "     "  Point
' 1951     24    Text   "  Domain
'
' 1975     36    Text  PASSword
' 2011      4    LInt  VOLume /month
' 2015     72    Text  RESTrictions (/SYSop /REAl Text etc.)
' 2087     36     "    ORIGin
' 2123     72     "    DISTribution
' 2195     72     "    GATEway
' 2267     16     "    GROUP
'
' 2283     36    Text  FROM (Messenger) Name
' 2319     80     "     "  Email address
' 2399      2    UInt   "  Zone
' 2401      2     "     "  Net
' 2403      2     "     "  Node
' 2405      2     "     "  Point
' 2407     24    Text   "  Domain
'
' 2431      2    Word  Date Created (yyyy)
' 2433      1    Bin    "           (mm)
' 2434      1     "     "           (dd)
'
' 2435      2    Word  Date Updated (yyyy)
' 2437      1    Bin    "           (mm)
' 2438      1     "     "           (dd)
'
' 2439      1    Bin   Warnings
' 2440      1     "    Status (0=Active, 1=Pending Deletion)
'
' 2441     36    Text  REPLY-to Name
' 2477     80     "     "  Email address
' 2557      2    UInt   "  Zone
' 2559      2     "     "  Net
' 2561      2     "     "  Node
' 2563      2     "     "  Point
' 2565     24    Text   "  Domain
'
' 2589   1500    Text  RULEs (20 lines x75)

' 4089    412    ???   (Open)
' ===== ======== ===== ==================================================
' Total  4500
'
' Notes: ALL Text fields are Binary Zero filled
'        Bin=Binary (Chr$), Text=ASCII Chars,
'        UInt=Unsigned Integer (CVI/MKI$),
'        LInt=Long Integer (CVL/MKL$),
'        Word=Word (CVWrd/MKWrd$)

' End of EList.Bas

